///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "MobParticle2Obj.h"
#include "MobFormat.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

///////////////////////////////////
//TParticle2ObjBlock
///////////////////////////////////

DWORD TParticle2ObjBlock::GetBlockSize()
//       .
{
  //...
  DWORD Result = 126;
  int i;
  //126 -       .

  //   ...
  Result = Result + NameStr.Length() + UnknStr1.Length();

  //  ...
  for (i = 0; i < SoundStr_s->Length; i++)
  {
    Result = Result + SoundStr_s->operator[](i).Length() + 8;
  };

  //         -
  //       - 8 .
  Result = Result + 8;

  return Result;
};

bool TParticle2ObjBlock::ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj)
//     .
{
  // ...
  DWORD TempDW1, MinBlockSgn, MinBlockSize, TempDW2, i;
  bool Result = true;
  __int64 Cursor = 8;

  //    .
  do
  {
    //  ...
    memcpy(&MinBlockSgn,&Buff[Cursor],4);
    Cursor = Cursor+4;
    //     ...
    if (MinBlockSgn == Ptl2_Sgn_SoundStr_s)
    {
      //    
      //DynamicArray <String>

      //   .
      SoundStr_s = new DynamicArray <String>;

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  
      memcpy(&TempDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (TempDW1 != 0)
      {
        //  ...
        // ...
        SoundStr_s->Length = TempDW1;

        i = -1;
        do
        {
          //   ...
          TempDW1 = TempDW1-1; //  -        
          i = i+1;

          Cursor = Cursor+4;  // 

          //  ...
          memcpy(&TempDW2,&Buff[Cursor],4);
          Cursor = Cursor+4;

          // ...
          if ((TempDW2 - 8) != 0)
          {
            SoundStr_s->operator[](i).SetLength((TempDW2 - 8));
            memcpy(&SoundStr_s->operator[](i)[1],&Buff[Cursor],(TempDW2 - 8));
            Cursor = Cursor+(TempDW2 - 8);
          }
          else
          {
            SoundStr_s->operator[](i) = "";
          };
        }
        while (TempDW1 != 0);
      }
      else
      {
        //  ...
        SoundStr_s->Length = 0;
      };
    }

    else if (MinBlockSgn == Ptl2_Sgn_ID)
    {
      // 
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&ID,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl2_Sgn_Coords)
    {
      //
      //float X 3

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&CoordX,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&CoordY,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&CoordZ,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl2_Sgn_UnknDw1)
    {
      // DW 1
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UnknDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl2_Sgn_UnknDw2)
    {
      // DW 2
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UnknDW2,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl2_Sgn_NameStr)
    {
      //    
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      NameStr.SetLength(MinBlockSize-8);

      if ((MinBlockSize-8) != 0)
      {
        // ...
        memcpy(&NameStr[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        NameStr = "";
      };
    }

    else if (MinBlockSgn == Ptl2_Sgn_UnknStr1)
    {
      //  1
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      UnknStr1.SetLength(MinBlockSize-8);

      if ((MinBlockSize-8) != 0)
      {
        // ...
        memcpy(&UnknStr1[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        UnknStr1 = "";
      };
    }

    else if (MinBlockSgn == Ptl2_Sgn_UnknDw3)
    {
      // DW 3
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UnknDW3,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl2_Sgn_UnknDw4)
    {
      // DW 4
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UnknDW4,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl2_Sgn_UnknByte1)
    {
      // byte 1
      //byte

      Cursor = Cursor+4;  //   -  .
      // ...
      memcpy(&UnknByte1,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Ptl2_Sgn_UnknByte2)
    {
      // byte 2
      //byte

      Cursor = Cursor+4;  //   -  .
      // ...
      memcpy(&UnknByte2,&Buff[Cursor],1);
      Cursor = Cursor+1;
    };

  }
  while (Cursor != BuffSize);

  StopLoadUnitBlock:        //     .
  ;
  return Result;
};

byte* TParticle2ObjBlock::GenBlock(DWORD& BlockSize)
// ...
{
  //
  byte* Result = NULL;
  int i = 0; //
  DWORD ChetireBaita, BlockSignature;
  DWORD Cursor = 0;

  //, .      ...
  BlockSize = GetBlockSize();
  Result = new byte[BlockSize];

  // ...
  memcpy(&Result[Cursor],&OB_Sgn_Particle2,4);
  Cursor = Cursor+4;

  // .
  memcpy(&Result[Cursor],&BlockSize,4);
  Cursor = Cursor+4;

  //    
  //DynamicArray <String>
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_SoundStr_s,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 0;
  for (i = 0; i < SoundStr_s->Length; i++)
  {
    ChetireBaita = ChetireBaita + SoundStr_s->operator[](i).Length() + 8;
  };
  ChetireBaita = ChetireBaita + 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //   ...
  ChetireBaita = SoundStr_s->Length;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  // ...
  for (i = 0; i < SoundStr_s->Length; i++)
  {
    // 
    memcpy(&Result[Cursor],&Ptl2_Sgn_SoundStr_s,4);
    Cursor = Cursor+4;
    // ...
    ChetireBaita = 8+SoundStr_s->operator[](i).Length();
    memcpy(&Result[Cursor],&ChetireBaita,4);
    Cursor = Cursor+4;
    //...
    if (SoundStr_s->operator[](i).Length() > 0)
    {
      memcpy(&Result[Cursor],&SoundStr_s->operator[](i)[1],SoundStr_s->operator[](i).Length());
      Cursor = Cursor+SoundStr_s->operator[](i).Length();
    };  
  };

  // 
  //DWORD
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_ID,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&ID,4);
  Cursor = Cursor+4;

  //
  //float X 3
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_Coords,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 20;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&CoordX,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&CoordY,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&CoordZ,4);
  Cursor = Cursor+4;

  // DW 1
  //DWORD
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_UnknDw1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknDW1,4);
  Cursor = Cursor+4;

  // DW 2
  //DWORD
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_UnknDw2,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknDW2,4);
  Cursor = Cursor+4;

  //    
  //String
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_NameStr,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+NameStr.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&NameStr[1],NameStr.Length());
    Cursor = Cursor+NameStr.Length();
  };

  //  1
  //String
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_UnknStr1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+UnknStr1.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&UnknStr1[1],UnknStr1.Length());
    Cursor = Cursor+UnknStr1.Length();
  };

  // DW 3
  //DWORD
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_UnknDw3,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknDW3,4);
  Cursor = Cursor+4;

  // DW 4
  //DWORD
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_UnknDw4,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknDW4,4);
  Cursor = Cursor+4;

  // byte 1
  //byte
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_UnknByte1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknByte1,1);
  Cursor = Cursor+1;

  // byte 2
  //byte
  // 
  memcpy(&Result[Cursor],&Ptl2_Sgn_UnknByte2,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknByte2,1);
  Cursor = Cursor+1;

  //  ...
  return Result;
};
